/***************************************************************
 *
 * Copyright (C) 1990-2007, Condor Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License.  You may
 * obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ***************************************************************/

#ifndef _GCB_ERRNO
#define _GCB_ERRNO

#define GCB_ESYSCALLFAILED 1001 // errno explains the reason best

#define GCB_EBROKERNOTAVAIL 1002 // Broker is not available
#define GCB_EBADMSGFORMAT 1003 // GCB message in a bad format received
#define GCB_EBADMSGTYPE 1004 // Invalid type of GCB message received
#define GCB_EINTERNALSOCK 1005 // the socket is being internally used by GCB
#define GCB_EBADARG 1006 // invalid argument is passed
#define GCB_ESOCKTNOSUPPORT 1007 // operation not supported for fd
#define GCB_ESOCKINVALIDSTATUS 1008 // the socket is in invalid status for the call
#define GCB_EPEERNOTREGISTERED 1009 // the peer is not registered to the dest Broker
#define GCB_ETIMEOUT 1010 // Can't hear from the dest in PASSIVE connection
#define GCB_EMISC 1011 // Can't explain why

// New errors can be added with a greater number than GCB_NO_ERROR_BEYOND_THIS.
// However a unique number must be exclusively used for GCB_NO_ERROR_BEYOND_THIS
#define GCB_NO_ERROR_BEYOND_THIS 3000

#ifndef _GCB_errno
extern int _GCB_errno;
#endif

#endif
