/***************************************************************
 *
 * Copyright (C) 1990-2007, Condor Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License.  You may
 * obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ***************************************************************/

#ifndef _GET_EXEC_PATH_H
#define _GET_EXEC_PATH_H

#ifdef __cplusplus
extern "C" {
#endif

/* 
   Utility function that returns the full path that the current
   process is executing from.  This is only implemented on platforms
   where the answer can be reliably determined (in very OS-dependent
   ways).  On other platforms, or in case of error, this returns NULL.
   In that case, the best the caller can hope for is to use ARGV[0].
   If this returns a value, it will be a string allocated with
   malloc() that must be free()'ed by the caller. 
*/

char* getExecPath();

#ifdef __cplusplus
}
#endif

#endif /* _GET_EXEC_PATH_H */
