/***************************************************************
 *
 * Copyright (C) 1990-2007, Condor Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License.  You may
 * obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ***************************************************************/

#include "gcb_common.h"
#include "GCB.h"

#define TCP_BUF_SIZE 100000

using namespace std;

static bool
sendData(int sock, char *buf, int size)
{
	int total, sent;

	total = 0;
	while(total < size) {
		sent = GCB_send(sock, &buf[total], size-total, 0);
		if (sent < 0) {
			if (errno != EINTR && errno != EAGAIN) {
				return false;
			} else {
				continue;
			}
		}
		total += sent;
	}
	return true;
}

int main(int argc, char *argv[])
{
	char buf[TCP_BUF_SIZE];

	while(1) {
		int read = GCB_recv(0, buf, sizeof(buf), 0);
		if (read < 0) {
			return -1;
		} else if (read == 0) {
			return 0;
		}

		if (sendData(0, buf, read) != true) {
			return -1;
		}
	}
}
