/***************************************************************
 *
 * Copyright (C) 1990-2007, Condor Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License.  You may
 * obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ***************************************************************/

#include "gcb_common.h"

static void
my_log_va(int level, char *fmt, va_list ap)
{
	char str[4000];

	sprintf(str, "my_log_va [%ld] %s:%d: ", (long)getpid(),
			Generic_log_srcfile, Generic_log_lineno);
	vsprintf(&str[strlen(str)], fmt, ap);
	if (write(2, str, strlen(str)) < 0) {
		fprintf(stderr, "Can't write log to the log file\n");
		fprintf(stderr, "Log msg: %s\n", str);
		exit(-1);
	}
	return;
}

int
main(int argc, char *argv[])
{
	printf("Logging with default log_va...\n");
	LOG(D_BASIC, "You should see this msg without the prefix of \"my_log_va\"\n");
	Generic_set_log_va(my_log_va);
	LOG(D_BASIC, "You should see this msg with the prefix of \"my_log_va\"\n");
	return 0;
}
