/***************************************************************
 *
 * Copyright (C) 1990-2007, Condor Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License.  You may
 * obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ***************************************************************/

#include "gcb_common.h"
#include "GCB.h"

int
main(int argc, char *argv[])
{
    int fd = atoi(argv[1]);
    int newfd = atoi(argv[2]);
    printf("echo_server: listen_sock(%d) accepted_sock(%d)\n", fd, newfd);

    GCB_close(fd);

    int bytes;
    int total, sent;
    char buf[10000];

    while(true) {
        bytes = GCB_recv(newfd, buf, 10000, 0);
        if (bytes < 0) {
            printf("GCB_recv failed: %s\n", strerror(errno));
            return -1;
        } else if (bytes == 0) {
            printf("client closed\n");
            return 0;
        }
        printf("\t%d bytes received\n", bytes);
        total = sent = 0;
        while(total < bytes) {
            sent = GCB_send(newfd, &buf[total], bytes - total, 0);
            if (sent < 0) {
                printf("GCB_send failed: %s\n", strerror(errno));
                return -1;
            }
            total += sent;
        }
        printf("\techoed\n");
    }
    return 0;
}
