/***************************************************************
 *
 * Copyright (C) 1990-2007, Condor Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License.  You may
 * obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ***************************************************************/

#include "gcb_common.h"
#include "GCB.h"

// run as "udp_client_1 server_ip port"
int
main(int argc, char *argv[])
{
    if (argc != 3) {
        printf("usage: udp_client_1 server_ip port\n");
        return -1;
    }

    int fd = GCB_socket(AF_INET, SOCK_DGRAM, 0);
    if (fd < 0) {
        printf("GCB_socket failed: %s\n", strerror(errno));
        return -1;
    }

    struct sockaddr_in peer;
    peer.sin_family = AF_INET;
    if (inet_aton(argv[1], &peer.sin_addr) < 0) {
        printf("ip address is in invalid form: %s\n", strerror(errno));
        return -1;
    }
    short port = atoi(argv[2]);
    peer.sin_port = htons(port);
    socklen_t addrlen = sizeof(struct sockaddr_in);

    while(1) {
        printf("***type string send: ");
        char sbuf[1000];
        (void) gets(sbuf);
        if (sbuf[0] == '!') {
            GCB_close(fd);
            return 0;
        }
        int sent = GCB_sendto(fd, sbuf, strlen(sbuf)+1, 0,
                (struct sockaddr *)&peer, addrlen);
        printf("***%d bytes sent\n", sent);
        char rbuf[500];
        struct sockaddr_in from;
        socklen_t fromlen = sizeof(struct sockaddr_in);
        int rcved = GCB_recvfrom(fd, rbuf, sent, 0,
                (struct sockaddr *)&from, &fromlen);
        if (rcved < 0) {
            printf("GCB_recvfrom failed: %s\n", strerror(errno));
            return -1;
        }
        for (int i=0; i<rcved; i++) {
            if (sbuf[i] != rbuf[i]) {
                printf("compare failed\n");
                return -1;
            }
        }
    }
}
