/***************************************************************
 *
 * Copyright (C) 1990-2007, Condor Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you
 * may not use this file except in compliance with the License.  You may
 * obtain a copy of the License at
 * 
 *    http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ***************************************************************/

#include "gcb_common.h"
#include "GCB.h"

int
main(int argc, char *argv[])
{
    int fd = atoi(argv[1]);
    printf("udp_echo_server: sock(%d)\n", fd);

    while(true) {
        struct sockaddr_in from;
        socklen_t fromlen = sizeof(struct sockaddr_in);
        char buf[1000];
        int bytes = GCB_recvfrom(fd, buf, 1000, 0,
                (struct sockaddr *)&from, &fromlen);
        if (bytes < 0) {
            printf("GCB_recvfrom failed: %s\n", strerror(errno));
            return -1;
        }
        printf("\t%d bytes received from: %s\n", bytes, _sin2str(&from));
        int sent = GCB_sendto(fd, buf, bytes, 0,
                (struct sockaddr *)&from, fromlen);
        if (sent < 0) {
            printf("GCB_sendto failed: %s\n", strerror(errno));
            return -1;
        }
    }
    return 0;
}
